import configparser
import os

hbn_array_p0 = os.environ.get('HBN_ARR_REPS_P0').split(' ')
hbn_array_p1 = os.environ.get('HBN_ARR_REPS_P1').split(' ')
hbn_array_uplinks = os.environ.get('HBN_ARR_UPLINKS').split(' ')
hbn_array_dpu_sfs = os.environ.get('HBN_ARR_DPU_SFS_ORIG').split(' ')
sfc_array_p0 = os.environ.get('SFC_ARR_REPS_P0').split(' ')
sfc_array_p1 = os.environ.get('SFC_ARR_REPS_P1').split(' ')
sfc_array_uplinks = os.environ.get('SFC_ARR_UPLINKS').split(' ')
sfc_array_dpu_sfs = os.environ.get('SFC_ARR_DPU_SFS_ORIG').split(' ')
array_patch_ports = os.environ.get('SFC_PATCH_PORTS').split(' ')
array_link_propagation = os.environ.get('LINK_PROPAGATION_ARR').split(' ')
enable_br_sfc = os.environ.get('ENABLE_BR_SFC').split(' ')
enable_br_sfc_default_flows = os.environ.get('ENABLE_BR_SFC_DEFAULT_FLOWS').split(' ')
config = configparser.ConfigParser(allow_no_value=True, delimiters=('='))

config['BR_HBN_UPLINKS'] = {}
for i in hbn_array_uplinks:
    config.set('BR_HBN_UPLINKS', i, None)
config['BR_HBN_REPS'] = {}
for i in hbn_array_p0:
    config.set('BR_HBN_REPS', i, None)
for i in hbn_array_p1:
    config.set('BR_HBN_REPS', i, None)
config['BR_HBN_SFS'] = {}
for i in hbn_array_dpu_sfs:
    config.set('BR_HBN_SFS', i, None)

config['BR_SFC_UPLINKS'] = {}
for i in sfc_array_uplinks:
    config.set('BR_SFC_UPLINKS', i, None)
config['BR_SFC_REPS'] = {}
for i in sfc_array_p0:
    if i:
        config.set('BR_SFC_REPS', i, None)
for i in sfc_array_p1:
    if i:
        config.set('BR_SFC_REPS', i, None)
config['BR_SFC_SFS'] = {}
for i in sfc_array_dpu_sfs:
    config.set('BR_SFC_SFS', i, None)

config['BR_HBN_SFC_PATCH_PORTS'] = {}
for i in array_patch_ports:
    config.set('BR_HBN_SFC_PATCH_PORTS', i, None)
config['LINK_PROPAGATION'] = {}
for i in array_link_propagation:
    config.set('LINK_PROPAGATION', i, None)

config['ENABLE_BR_SFC'] = {}
for i in enable_br_sfc:
    config.set('ENABLE_BR_SFC', i, None)
config['ENABLE_BR_SFC_DEFAULT_FLOWS'] = {}
for i in enable_br_sfc_default_flows:
    config.set('ENABLE_BR_SFC_DEFAULT_FLOWS', i, None)

with open('/etc/mellanox/hbn.conf', 'w') as configfile:
    config.write(configfile)
